import unittest
import AutoRPE.UtilsRPE.NatureDeterminer as NatureDeterminer

class TestNatureDeterminer(unittest.TestCase):

    def test_is_an_hardcoded_array_1(self):
        string = '(/llnon,llson,llean,llwen/)'
        self.assertTrue(NatureDeterminer.is_an_hardcoded_array(string))

    def test_is_an_hardcoded_array_2(self):
        string =  '(/2,1/)'
        self.assertTrue(NatureDeterminer.is_an_hardcoded_array(string))

    def test_is_an_hardcoded_array_2(self):
        string = '(/(zshift+REAL(ji,wp),ji=1,jpi_crs*jpj_crs)/)'
        self.assertTrue(NatureDeterminer.is_an_hardcoded_array(string))

    def test_is_an_hardcoded_array_3(self):
        string = 'RESHAPE((/pfield1d/),(/1,1,SIZE(pfield1d)/))'
        self.assertFalse(NatureDeterminer.is_an_hardcoded_array(string))

    def test_has_operations(self):
        string = 'SUM( a_i(:,:,:)%val - a_i_b(:,:,:)%val, dim=3 ) * r1_Dt_ice'
        self.assertTrue(NatureDeterminer.has_operations(string))

    def test_has_operations_2(self):
        # Some cases that appear in NEMO
        cases = [
            'kndims=indims',
            'lduld=lluld',
            'kfillmode=jpfillnothing',
            'lsend=llsend2',
            'ktype = jp_i4',
            'pfillval=1.0_wp',

        ]
        for case in cases:
            self.assertFalse(NatureDeterminer.has_operations(case))

    def test_has_intrinsics(self):
        string = 'MAXVAL(zCu_cfl%val,dim=3)'
        self.assertTrue(NatureDeterminer.has_intrinsics(string))



if __name__ == '__main__':
    unittest.main()
